/* THIS FILE IS AUTOGENERATED FROM Highlight.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_HighlightBinding_h
#define mozilla_dom_HighlightBinding_h

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

class AbstractRange;
class Highlight;
class HighlightRegistry;
struct NativePropertyHooks;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

enum class HighlightType : uint8_t {
  Highlight,
  Spelling_error,
  Grammar_error,
  EndGuard_
};

namespace HighlightTypeValues {
extern const EnumEntry strings[4];

static constexpr size_t Count = 3;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(HighlightType::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(HighlightType stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace HighlightTypeValues

bool
ToJSValue(JSContext* aCx, HighlightType aArgument, JS::MutableHandle<JS::Value> aValue);


namespace Highlight_Binding {

  typedef mozilla::dom::Highlight NativeType;

  namespace SetlikeHelpers {
  void
  Clear(mozilla::dom::Highlight* self, ErrorResult& aRv);
  bool
  Delete(mozilla::dom::Highlight* self, AbstractRange& aKey, ErrorResult& aRv);
  bool
  Has(mozilla::dom::Highlight* self, AbstractRange& aKey, ErrorResult& aRv);
  void
  Add(mozilla::dom::Highlight* self, AbstractRange& aKey, ErrorResult& aRv);
  } // namespace SetlikeHelpers

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::Highlight* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::Highlight,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::Highlight,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace Highlight_Binding



namespace HighlightRegistry_Binding {

  typedef mozilla::dom::HighlightRegistry NativeType;

  namespace MaplikeHelpers {
  void
  Clear(mozilla::dom::HighlightRegistry* self, ErrorResult& aRv);
  bool
  Delete(mozilla::dom::HighlightRegistry* self, const nsAString& aKey, ErrorResult& aRv);
  bool
  Has(mozilla::dom::HighlightRegistry* self, const nsAString& aKey, ErrorResult& aRv);
  void
  Set(mozilla::dom::HighlightRegistry* self, const nsAString& aKey, Highlight& aValue, ErrorResult& aRv);
  already_AddRefed<Highlight>
  Get(mozilla::dom::HighlightRegistry* self, const nsAString& aKey, ErrorResult& aRv);
  } // namespace MaplikeHelpers

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::HighlightRegistry* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::HighlightRegistry,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::HighlightRegistry,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace HighlightRegistry_Binding



} // namespace mozilla::dom

#endif // mozilla_dom_HighlightBinding_h
