/* THIS FILE IS AUTOGENERATED FROM VideoColorSpace.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_VideoColorSpaceBinding_h
#define mozilla_dom_VideoColorSpaceBinding_h

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

struct NativePropertyHooks;
class ProtoAndIfaceCache;
class VideoColorSpace;
struct VideoColorSpaceInitAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

enum class VideoColorPrimaries : uint8_t {
  Bt709,
  Bt470bg,
  Smpte170m,
  Bt2020,
  Smpte432,
  EndGuard_
};

namespace VideoColorPrimariesValues {
extern const EnumEntry strings[6];

static constexpr size_t Count = 5;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(VideoColorPrimaries::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(VideoColorPrimaries stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace VideoColorPrimariesValues

bool
ToJSValue(JSContext* aCx, VideoColorPrimaries aArgument, JS::MutableHandle<JS::Value> aValue);


enum class VideoTransferCharacteristics : uint8_t {
  Bt709,
  Smpte170m,
  Iec61966_2_1,
  Linear,
  Pq,
  Hlg,
  EndGuard_
};

namespace VideoTransferCharacteristicsValues {
extern const EnumEntry strings[7];

static constexpr size_t Count = 6;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(VideoTransferCharacteristics::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(VideoTransferCharacteristics stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace VideoTransferCharacteristicsValues

bool
ToJSValue(JSContext* aCx, VideoTransferCharacteristics aArgument, JS::MutableHandle<JS::Value> aValue);


enum class VideoMatrixCoefficients : uint8_t {
  Rgb,
  Bt709,
  Bt470bg,
  Smpte170m,
  Bt2020_ncl,
  EndGuard_
};

namespace VideoMatrixCoefficientsValues {
extern const EnumEntry strings[6];

static constexpr size_t Count = 5;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(VideoMatrixCoefficients::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(VideoMatrixCoefficients stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace VideoMatrixCoefficientsValues

bool
ToJSValue(JSContext* aCx, VideoMatrixCoefficients aArgument, JS::MutableHandle<JS::Value> aValue);


struct VideoColorSpaceInit : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Nullable<bool> mFullRange;
  MOZ_INIT_OUTSIDE_CTOR Nullable<VideoMatrixCoefficients> mMatrix;
  MOZ_INIT_OUTSIDE_CTOR Nullable<VideoColorPrimaries> mPrimaries;
  MOZ_INIT_OUTSIDE_CTOR Nullable<VideoTransferCharacteristics> mTransfer;

  VideoColorSpaceInit();

  explicit inline VideoColorSpaceInit(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  VideoColorSpaceInit(VideoColorSpaceInit&& aOther) = default;

  explicit inline VideoColorSpaceInit(const VideoColorSpaceInit& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  VideoColorSpaceInit&
  operator=(const VideoColorSpaceInit& aOther);

private:
  static bool
  InitIds(JSContext* cx, VideoColorSpaceInitAtoms* atomsCache);
};

namespace binding_detail {
struct FastVideoColorSpaceInit : public VideoColorSpaceInit
{
  inline FastVideoColorSpaceInit()
    : VideoColorSpaceInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace VideoColorSpace_Binding {

  typedef mozilla::dom::VideoColorSpace NativeType;

  MOZ_CAN_RUN_SCRIPT bool
  CollectJSONAttributes(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::VideoColorSpace* self, JS::Rooted<JSObject*>& result);

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::VideoColorSpace* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::VideoColorSpace,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::VideoColorSpace,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace VideoColorSpace_Binding



} // namespace mozilla::dom

#endif // mozilla_dom_VideoColorSpaceBinding_h
