/* THIS FILE IS AUTOGENERATED FROM Sanitizer.webidl BY Codegen.py - DO NOT EDIT */

#include <type_traits>
#include "AtomList.h"
#include "MainThreadUtils.h"
#include "SanitizerBinding.h"
#include "WrapperFactory.h"
#include "js/Array.h"
#include "js/CallAndConstruct.h"
#include "js/Exception.h"
#include "js/ForOfIterator.h"
#include "js/MapAndSet.h"
#include "js/Object.h"
#include "js/PropertyAndElement.h"
#include "js/PropertyDescriptor.h"
#include "js/experimental/JitInfo.h"
#include "jsapi.h"
#include "mozilla/Atomics.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/StaticPrefs_dom.h"
#include "mozilla/UseCounter.h"
#include "mozilla/dom/BindingCallContext.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/Document.h"
#include "mozilla/dom/DocumentFragment.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/Sanitizer.h"
#include "mozilla/dom/ScriptSettings.h"
#include "mozilla/dom/SimpleGlobalObject.h"
#include "mozilla/dom/WebIDLPrefs.h"
#include "mozilla/dom/XrayExpandoClass.h"

namespace mozilla::dom {

namespace binding_detail {}; // Just to make sure it's known as a namespace
using namespace mozilla::dom::binding_detail;


namespace StarValues {
extern const EnumEntry strings[2] = {
  {"*", 1},
  { nullptr, 0 }
};
} // namespace StarValues

bool
ToJSValue(JSContext* aCx, Star aArgument, JS::MutableHandle<JS::Value> aValue)
{
  MOZ_ASSERT(uint32_t(aArgument) < ArrayLength(StarValues::strings));
  JSString* resultStr =
    JS_NewStringCopyN(aCx, StarValues::strings[uint32_t(aArgument)].value,
                      StarValues::strings[uint32_t(aArgument)].length);
  if (!resultStr) {
    return false;
  }
  aValue.setString(resultStr);
  return true;
}


void
ImplCycleCollectionTraverse(nsCycleCollectionTraversalCallback& aCallback, OwningDocumentFragmentOrDocument& aUnion, const char* aName, uint32_t aFlags)
{
  if (aUnion.IsDocumentFragment()) {
    ImplCycleCollectionTraverse(aCallback, aUnion.GetAsDocumentFragment(), "mDocumentFragment", aFlags);
  } else if (aUnion.IsDocument()) {
    ImplCycleCollectionTraverse(aCallback, aUnion.GetAsDocument(), "mDocument", aFlags);
  }
}


void
ImplCycleCollectionUnlink(OwningDocumentFragmentOrDocument& aUnion)
{
  aUnion.Uninit();
}


bool
DocumentFragmentOrDocument::TrySetToDocumentFragment(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    NonNull<mozilla::dom::DocumentFragment>& memberSlot = RawSetAsDocumentFragment();
    {
      // Our JSContext should be in the right global to do unwrapping in.
      nsresult rv = UnwrapObject<prototypes::id::DocumentFragment, mozilla::dom::DocumentFragment>(value, memberSlot, cx);
      if (NS_FAILED(rv)) {
        DestroyDocumentFragment();
        tryNext = true;
        return true;
      }
    }
  }
  return true;
}

bool
DocumentFragmentOrDocument::TrySetToDocumentFragment(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToDocumentFragment(cx, value, tryNext, passedToJSImpl);
}







bool
DocumentFragmentOrDocument::TrySetToDocument(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    NonNull<mozilla::dom::Document>& memberSlot = RawSetAsDocument();
    {
      // Our JSContext should be in the right global to do unwrapping in.
      nsresult rv = UnwrapObject<prototypes::id::Document, mozilla::dom::Document>(value, memberSlot, cx);
      if (NS_FAILED(rv)) {
        DestroyDocument();
        tryNext = true;
        return true;
      }
    }
  }
  return true;
}

bool
DocumentFragmentOrDocument::TrySetToDocument(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToDocument(cx, value, tryNext, passedToJSImpl);
}







bool
DocumentFragmentOrDocument::Init(BindingCallContext& cx, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  MOZ_ASSERT(mType == eUninitialized);

  bool done = false, failed = false, tryNext;
  if (value.isObject()) {
    done = (failed = !TrySetToDocumentFragment(cx, value, tryNext, passedToJSImpl)) || !tryNext ||
           (failed = !TrySetToDocument(cx, value, tryNext, passedToJSImpl)) || !tryNext;
  }
  if (failed) {
    return false;
  }
  if (!done) {
    cx.ThrowErrorMessage<MSG_NOT_IN_UNION>(sourceDescription, "DocumentFragment, Document");
    return false;
  }
  return true;
}

bool
DocumentFragmentOrDocument::Init(JSContext* cx_, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, value, sourceDescription, passedToJSImpl);
}


bool
DocumentFragmentOrDocument::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
    }
    case eDocumentFragment: {
      if (!GetOrCreateDOMReflector(cx, mValue.mDocumentFragment.Value(), rval)) {
        MOZ_ASSERT(JS_IsExceptionPending(cx));
        return false;
      }
      return true;
    }
    case eDocument: {
      if (!GetOrCreateDOMReflector(cx, mValue.mDocument.Value(), rval)) {
        MOZ_ASSERT(JS_IsExceptionPending(cx));
        return false;
      }
      return true;
    }
    default: {
      return false;
    }
  }
}



OwningDocumentFragmentOrDocument::OwningDocumentFragmentOrDocument(OwningDocumentFragmentOrDocument&& aOther)
  : mType(eUninitialized)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eDocumentFragment: {
      mType = eDocumentFragment;
      mValue.mDocumentFragment.SetValue(std::move(aOther.mValue.mDocumentFragment.Value()));
      break;
    }
    case eDocument: {
      mType = eDocument;
      mValue.mDocument.SetValue(std::move(aOther.mValue.mDocument.Value()));
      break;
    }
  }
}



bool
OwningDocumentFragmentOrDocument::TrySetToDocumentFragment(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    OwningNonNull<mozilla::dom::DocumentFragment>& memberSlot = RawSetAsDocumentFragment();
    static_assert(IsRefcounted<mozilla::dom::DocumentFragment>::value, "We can only store refcounted classes.");
    {
      // Our JSContext should be in the right global to do unwrapping in.
      nsresult rv = UnwrapObject<prototypes::id::DocumentFragment, mozilla::dom::DocumentFragment>(value, memberSlot, cx);
      if (NS_FAILED(rv)) {
        DestroyDocumentFragment();
        tryNext = true;
        return true;
      }
    }
  }
  return true;
}

bool
OwningDocumentFragmentOrDocument::TrySetToDocumentFragment(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToDocumentFragment(cx, value, tryNext, passedToJSImpl);
}

OwningNonNull<mozilla::dom::DocumentFragment>&
OwningDocumentFragmentOrDocument::RawSetAsDocumentFragment()
{
  if (mType == eDocumentFragment) {
    return mValue.mDocumentFragment.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eDocumentFragment;
  return mValue.mDocumentFragment.SetValue();
}

OwningNonNull<mozilla::dom::DocumentFragment>&
OwningDocumentFragmentOrDocument::SetAsDocumentFragment()
{
  if (mType == eDocumentFragment) {
    return mValue.mDocumentFragment.Value();
  }
  Uninit();
  mType = eDocumentFragment;
  return mValue.mDocumentFragment.SetValue();
}


void
OwningDocumentFragmentOrDocument::DestroyDocumentFragment()
{
  MOZ_RELEASE_ASSERT(IsDocumentFragment(), "Wrong type!");
  mValue.mDocumentFragment.Destroy();
  mType = eUninitialized;
}



bool
OwningDocumentFragmentOrDocument::TrySetToDocument(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    OwningNonNull<mozilla::dom::Document>& memberSlot = RawSetAsDocument();
    static_assert(IsRefcounted<mozilla::dom::Document>::value, "We can only store refcounted classes.");
    {
      // Our JSContext should be in the right global to do unwrapping in.
      nsresult rv = UnwrapObject<prototypes::id::Document, mozilla::dom::Document>(value, memberSlot, cx);
      if (NS_FAILED(rv)) {
        DestroyDocument();
        tryNext = true;
        return true;
      }
    }
  }
  return true;
}

bool
OwningDocumentFragmentOrDocument::TrySetToDocument(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToDocument(cx, value, tryNext, passedToJSImpl);
}

OwningNonNull<mozilla::dom::Document>&
OwningDocumentFragmentOrDocument::RawSetAsDocument()
{
  if (mType == eDocument) {
    return mValue.mDocument.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eDocument;
  return mValue.mDocument.SetValue();
}

OwningNonNull<mozilla::dom::Document>&
OwningDocumentFragmentOrDocument::SetAsDocument()
{
  if (mType == eDocument) {
    return mValue.mDocument.Value();
  }
  Uninit();
  mType = eDocument;
  return mValue.mDocument.SetValue();
}


void
OwningDocumentFragmentOrDocument::DestroyDocument()
{
  MOZ_RELEASE_ASSERT(IsDocument(), "Wrong type!");
  mValue.mDocument.Destroy();
  mType = eUninitialized;
}



bool
OwningDocumentFragmentOrDocument::Init(BindingCallContext& cx, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  MOZ_ASSERT(mType == eUninitialized);

  bool done = false, failed = false, tryNext;
  if (value.isObject()) {
    done = (failed = !TrySetToDocumentFragment(cx, value, tryNext, passedToJSImpl)) || !tryNext ||
           (failed = !TrySetToDocument(cx, value, tryNext, passedToJSImpl)) || !tryNext;
  }
  if (failed) {
    return false;
  }
  if (!done) {
    cx.ThrowErrorMessage<MSG_NOT_IN_UNION>(sourceDescription, "DocumentFragment, Document");
    return false;
  }
  return true;
}

bool
OwningDocumentFragmentOrDocument::Init(JSContext* cx_, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, value, sourceDescription, passedToJSImpl);
}

void
OwningDocumentFragmentOrDocument::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eDocumentFragment: {
      DestroyDocumentFragment();
      break;
    }
    case eDocument: {
      DestroyDocument();
      break;
    }
  }
}

bool
OwningDocumentFragmentOrDocument::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
    }
    case eDocumentFragment: {
      if (!GetOrCreateDOMReflector(cx, mValue.mDocumentFragment.Value(), rval)) {
        MOZ_ASSERT(JS_IsExceptionPending(cx));
        return false;
      }
      return true;
    }
    case eDocument: {
      if (!GetOrCreateDOMReflector(cx, mValue.mDocument.Value(), rval)) {
        MOZ_ASSERT(JS_IsExceptionPending(cx));
        return false;
      }
      return true;
    }
    default: {
      return false;
    }
  }
}

OwningDocumentFragmentOrDocument&
OwningDocumentFragmentOrDocument::operator=(OwningDocumentFragmentOrDocument&& aOther)
{
  this->~OwningDocumentFragmentOrDocument();
  new (this) OwningDocumentFragmentOrDocument (std::move(aOther));
  return *this;
}


OwningDocumentFragmentOrDocument&
OwningDocumentFragmentOrDocument::operator=(const OwningDocumentFragmentOrDocument& aOther)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eDocumentFragment: {
      SetAsDocumentFragment() = aOther.GetAsDocumentFragment();
      break;
    }
    case eDocument: {
      SetAsDocument() = aOther.GetAsDocument();
      break;
    }
  }
  return *this;
}



SanitizerElementNamespace::SanitizerElementNamespace()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}




bool
SanitizerElementNamespace::InitIds(JSContext* cx, SanitizerElementNamespaceAtoms* atomsCache)
{
  MOZ_ASSERT(reinterpret_cast<jsid*>(atomsCache)->isVoid());

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->namespace_id.init(cx, "namespace") ||
      !atomsCache->name_id.init(cx, "name")) {
    return false;
  }
  return true;
}

bool
SanitizerElementNamespace::Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  SanitizerElementNamespaceAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<SanitizerElementNamespaceAtoms>(cx);
    if (reinterpret_cast<jsid*>(atomsCache)->isVoid() &&
        !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(val)) {
    return cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>(sourceDescription, "dictionary");
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->name_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mName)) {
      return false;
    }
    mIsAnyMemberPresent = true;
  } else if (cx) {
    // Don't error out if we have no cx.  In that
    // situation the caller is default-constructing us and we'll
    // just assume they know what they're doing.
    return cx.ThrowErrorMessage<MSG_MISSING_REQUIRED_DICTIONARY_MEMBER>("'name' member of SanitizerElementNamespace");
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->namespace_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mNamespace)) {
      return false;
    }
    mIsAnyMemberPresent = true;
  } else if (cx) {
    // Don't error out if we have no cx.  In that
    // situation the caller is default-constructing us and we'll
    // just assume they know what they're doing.
    return cx.ThrowErrorMessage<MSG_MISSING_REQUIRED_DICTIONARY_MEMBER>("'namespace' member of SanitizerElementNamespace");
  }
  return true;
}

bool
SanitizerElementNamespace::Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // We don't want to use sourceDescription for our context here;
  // that's not really what it's formatted for.
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, val, sourceDescription, passedToJSImpl);
}

bool
SanitizerElementNamespace::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  SanitizerElementNamespaceAtoms* atomsCache = GetAtomCache<SanitizerElementNamespaceAtoms>(cx);
  if (reinterpret_cast<jsid*>(atomsCache)->isVoid() &&
      !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mName;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->name_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mNamespace;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->namespace_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(false);

  return true;
}

void
SanitizerElementNamespace::TraceDictionary(JSTracer* trc)
{
}

SanitizerElementNamespace&
SanitizerElementNamespace::operator=(const SanitizerElementNamespace& aOther)
{
  DictionaryBase::operator=(aOther);
  mName = aOther.mName;
  mNamespace = aOther.mNamespace;
  return *this;
}

bool
SanitizerElementNamespace::operator==(const SanitizerElementNamespace& aOther) const
{
  if (mName != aOther.mName) {
      return false;
  }
  if (mNamespace != aOther.mNamespace) {
      return false;
  }
  return true;
}


bool
StringOrSanitizerElementNamespace::TrySetToString(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    binding_detail::FakeString<char16_t>& memberSlot = RawSetAsString();
    if (!ConvertJSValueToString(cx, value, eStringify, eStringify, memberSlot)) {
      return false;
    }
  }
  return true;
}








bool
StringOrSanitizerElementNamespace::TrySetToSanitizerElementNamespace(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    binding_detail::FastSanitizerElementNamespace& memberSlot = RawSetAsSanitizerElementNamespace();
    if (!IsConvertibleToDictionary(value)) {
      DestroySanitizerElementNamespace();
      tryNext = true;
      return true;
    }
    if (!memberSlot.Init(cx, value, "SanitizerElementNamespace branch of (DOMString or SanitizerElementNamespace)", passedToJSImpl)) {
      return false;
    }
  }
  return true;
}

bool
StringOrSanitizerElementNamespace::TrySetToSanitizerElementNamespace(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToSanitizerElementNamespace(cx, value, tryNext, passedToJSImpl);
}







bool
StringOrSanitizerElementNamespace::Init(BindingCallContext& cx, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  MOZ_ASSERT(mType == eUninitialized);

  bool done = false, failed = false, tryNext;
  if (!done) {
    done = (failed = !TrySetToSanitizerElementNamespace(cx, value, tryNext, passedToJSImpl)) || !tryNext;
  }
  if (!done) {
    do {
      done = (failed = !TrySetToString(cx, value, tryNext)) || !tryNext;
      break;
    } while (false);
  }
  if (failed) {
    return false;
  }
  if (!done) {
    cx.ThrowErrorMessage<MSG_NOT_IN_UNION>(sourceDescription, "SanitizerElementNamespace");
    return false;
  }
  return true;
}

bool
StringOrSanitizerElementNamespace::Init(JSContext* cx_, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, value, sourceDescription, passedToJSImpl);
}


bool
StringOrSanitizerElementNamespace::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
    }
    case eString: {
      if (!xpc::NonVoidStringToJsval(cx, mValue.mString.Value(), rval)) {
        return false;
      }
      return true;
    }
    case eSanitizerElementNamespace: {
      if (!mValue.mSanitizerElementNamespace.Value().ToObjectInternal(cx, rval)) {
        return false;
      }
      return true;
    }
    default: {
      return false;
    }
  }
}



OwningStringOrSanitizerElementNamespace::OwningStringOrSanitizerElementNamespace(OwningStringOrSanitizerElementNamespace&& aOther)
  : mType(eUninitialized)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eString: {
      mType = eString;
      mValue.mString.SetValue(std::move(aOther.mValue.mString.Value()));
      break;
    }
    case eSanitizerElementNamespace: {
      mType = eSanitizerElementNamespace;
      mValue.mSanitizerElementNamespace.SetValue(std::move(aOther.mValue.mSanitizerElementNamespace.Value()));
      break;
    }
  }
}



bool
OwningStringOrSanitizerElementNamespace::TrySetToString(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    nsString& memberSlot = RawSetAsString();
    if (!ConvertJSValueToString(cx, value, eStringify, eStringify, memberSlot)) {
      return false;
    }
  }
  return true;
}

nsString&
OwningStringOrSanitizerElementNamespace::RawSetAsString()
{
  if (mType == eString) {
    return mValue.mString.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eString;
  return mValue.mString.SetValue();
}

nsString&
OwningStringOrSanitizerElementNamespace::SetAsString()
{
  if (mType == eString) {
    return mValue.mString.Value();
  }
  Uninit();
  mType = eString;
  return mValue.mString.SetValue();
}



void
OwningStringOrSanitizerElementNamespace::DestroyString()
{
  MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
  mValue.mString.Destroy();
  mType = eUninitialized;
}



bool
OwningStringOrSanitizerElementNamespace::TrySetToSanitizerElementNamespace(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    SanitizerElementNamespace& memberSlot = RawSetAsSanitizerElementNamespace();
    if (!IsConvertibleToDictionary(value)) {
      DestroySanitizerElementNamespace();
      tryNext = true;
      return true;
    }
    if (!memberSlot.Init(cx, value, "SanitizerElementNamespace branch of (DOMString or SanitizerElementNamespace)", passedToJSImpl)) {
      return false;
    }
  }
  return true;
}

bool
OwningStringOrSanitizerElementNamespace::TrySetToSanitizerElementNamespace(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToSanitizerElementNamespace(cx, value, tryNext, passedToJSImpl);
}

SanitizerElementNamespace&
OwningStringOrSanitizerElementNamespace::RawSetAsSanitizerElementNamespace()
{
  if (mType == eSanitizerElementNamespace) {
    return mValue.mSanitizerElementNamespace.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eSanitizerElementNamespace;
  return mValue.mSanitizerElementNamespace.SetValue();
}

SanitizerElementNamespace&
OwningStringOrSanitizerElementNamespace::SetAsSanitizerElementNamespace()
{
  if (mType == eSanitizerElementNamespace) {
    return mValue.mSanitizerElementNamespace.Value();
  }
  Uninit();
  mType = eSanitizerElementNamespace;
  return mValue.mSanitizerElementNamespace.SetValue();
}


void
OwningStringOrSanitizerElementNamespace::DestroySanitizerElementNamespace()
{
  MOZ_RELEASE_ASSERT(IsSanitizerElementNamespace(), "Wrong type!");
  mValue.mSanitizerElementNamespace.Destroy();
  mType = eUninitialized;
}



bool
OwningStringOrSanitizerElementNamespace::Init(BindingCallContext& cx, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  MOZ_ASSERT(mType == eUninitialized);

  bool done = false, failed = false, tryNext;
  if (!done) {
    done = (failed = !TrySetToSanitizerElementNamespace(cx, value, tryNext, passedToJSImpl)) || !tryNext;
  }
  if (!done) {
    do {
      done = (failed = !TrySetToString(cx, value, tryNext)) || !tryNext;
      break;
    } while (false);
  }
  if (failed) {
    return false;
  }
  if (!done) {
    cx.ThrowErrorMessage<MSG_NOT_IN_UNION>(sourceDescription, "SanitizerElementNamespace");
    return false;
  }
  return true;
}

bool
OwningStringOrSanitizerElementNamespace::Init(JSContext* cx_, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, value, sourceDescription, passedToJSImpl);
}

void
OwningStringOrSanitizerElementNamespace::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eString: {
      DestroyString();
      break;
    }
    case eSanitizerElementNamespace: {
      DestroySanitizerElementNamespace();
      break;
    }
  }
}

bool
OwningStringOrSanitizerElementNamespace::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
    }
    case eString: {
      if (!xpc::NonVoidStringToJsval(cx, mValue.mString.Value(), rval)) {
        return false;
      }
      return true;
    }
    case eSanitizerElementNamespace: {
      if (!mValue.mSanitizerElementNamespace.Value().ToObjectInternal(cx, rval)) {
        return false;
      }
      return true;
    }
    default: {
      return false;
    }
  }
}

OwningStringOrSanitizerElementNamespace&
OwningStringOrSanitizerElementNamespace::operator=(OwningStringOrSanitizerElementNamespace&& aOther)
{
  this->~OwningStringOrSanitizerElementNamespace();
  new (this) OwningStringOrSanitizerElementNamespace (std::move(aOther));
  return *this;
}


OwningStringOrSanitizerElementNamespace&
OwningStringOrSanitizerElementNamespace::operator=(const OwningStringOrSanitizerElementNamespace& aOther)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eString: {
      SetAsString() = aOther.GetAsString();
      break;
    }
    case eSanitizerElementNamespace: {
      SetAsSanitizerElementNamespace() = aOther.GetAsSanitizerElementNamespace();
      break;
    }
  }
  return *this;
}


bool
StarOrStringOrSanitizerElementNamespaceSequence::TrySetToStar(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    Star& memberSlot = RawSetAsStar();
    {
      int index;
      if (!FindEnumStringIndex<true>(cx, value, StarValues::strings, "Star", "Star branch of (Star or sequence<(DOMString or SanitizerElementNamespace)>)", &index)) {
        return false;
      }
      MOZ_ASSERT(index >= 0);
      memberSlot = static_cast<Star>(index);
    }
  }
  return true;
}

bool
StarOrStringOrSanitizerElementNamespaceSequence::TrySetToStar(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToStar(cx, value, tryNext, passedToJSImpl);
}







bool
StarOrStringOrSanitizerElementNamespaceSequence::TrySetToStringOrSanitizerElementNamespaceSequence(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    binding_detail::AutoSequence<OwningStringOrSanitizerElementNamespace>& memberSlot = RawSetAsStringOrSanitizerElementNamespaceSequence();
    JS::ForOfIterator iter(cx);
    if (!iter.init(value, JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      DestroyStringOrSanitizerElementNamespaceSequence();
      tryNext = true;
      return true;
    }
    binding_detail::AutoSequence<OwningStringOrSanitizerElementNamespace> &arr = memberSlot;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      OwningStringOrSanitizerElementNamespace* slotPtr = arr.AppendElement(mozilla::fallible);
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      OwningStringOrSanitizerElementNamespace& slot = *slotPtr;
      if (!slot.Init(cx, temp, "Element of sequence<(DOMString or SanitizerElementNamespace)> branch of (Star or sequence<(DOMString or SanitizerElementNamespace)>)", passedToJSImpl)) {
        return false;
      }
    }
  }
  return true;
}

bool
StarOrStringOrSanitizerElementNamespaceSequence::TrySetToStringOrSanitizerElementNamespaceSequence(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToStringOrSanitizerElementNamespaceSequence(cx, value, tryNext, passedToJSImpl);
}







bool
StarOrStringOrSanitizerElementNamespaceSequence::Init(BindingCallContext& cx, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  MOZ_ASSERT(mType == eUninitialized);

  bool done = false, failed = false, tryNext;
  if (value.isObject()) {
    done = (failed = !TrySetToStringOrSanitizerElementNamespaceSequence(cx, value, tryNext, passedToJSImpl)) || !tryNext;
  }
  if (!done) {
    do {
      done = (failed = !TrySetToStar(cx, value, tryNext)) || !tryNext;
      break;
    } while (false);
  }
  if (failed) {
    return false;
  }
  if (!done) {
    cx.ThrowErrorMessage<MSG_NOT_IN_UNION>(sourceDescription, "sequence<(DOMString or SanitizerElementNamespace)>");
    return false;
  }
  return true;
}

bool
StarOrStringOrSanitizerElementNamespaceSequence::Init(JSContext* cx_, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, value, sourceDescription, passedToJSImpl);
}


bool
StarOrStringOrSanitizerElementNamespaceSequence::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
    }
    case eStar: {
      if (!ToJSValue(cx, mValue.mStar.Value(), rval)) {
        return false;
      }
      return true;
    }
    case eStringOrSanitizerElementNamespaceSequence: {

      uint32_t length = mValue.mStringOrSanitizerElementNamespaceSequence.Value().Length();
      JS::Rooted<JSObject*> returnArray(cx, JS::NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            if (!mValue.mStringOrSanitizerElementNamespaceSequence.Value()[sequenceIdx0].ToJSVal(cx, returnArray, &tmp)) {
              return false;
            }
            break;
          } while (false);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      rval.setObject(*returnArray);
      return true;
    }
    default: {
      return false;
    }
  }
}



OwningStarOrStringOrSanitizerElementNamespaceSequence::OwningStarOrStringOrSanitizerElementNamespaceSequence(OwningStarOrStringOrSanitizerElementNamespaceSequence&& aOther)
  : mType(eUninitialized)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eStar: {
      mType = eStar;
      mValue.mStar.SetValue(std::move(aOther.mValue.mStar.Value()));
      break;
    }
    case eStringOrSanitizerElementNamespaceSequence: {
      mType = eStringOrSanitizerElementNamespaceSequence;
      mValue.mStringOrSanitizerElementNamespaceSequence.SetValue(std::move(aOther.mValue.mStringOrSanitizerElementNamespaceSequence.Value()));
      break;
    }
  }
}



bool
OwningStarOrStringOrSanitizerElementNamespaceSequence::TrySetToStar(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    Star& memberSlot = RawSetAsStar();
    {
      int index;
      if (!FindEnumStringIndex<true>(cx, value, StarValues::strings, "Star", "Star branch of (Star or sequence<(DOMString or SanitizerElementNamespace)>)", &index)) {
        return false;
      }
      MOZ_ASSERT(index >= 0);
      memberSlot = static_cast<Star>(index);
    }
  }
  return true;
}

bool
OwningStarOrStringOrSanitizerElementNamespaceSequence::TrySetToStar(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToStar(cx, value, tryNext, passedToJSImpl);
}

Star&
OwningStarOrStringOrSanitizerElementNamespaceSequence::RawSetAsStar()
{
  if (mType == eStar) {
    return mValue.mStar.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eStar;
  return mValue.mStar.SetValue();
}

Star&
OwningStarOrStringOrSanitizerElementNamespaceSequence::SetAsStar()
{
  if (mType == eStar) {
    return mValue.mStar.Value();
  }
  Uninit();
  mType = eStar;
  return mValue.mStar.SetValue();
}


void
OwningStarOrStringOrSanitizerElementNamespaceSequence::DestroyStar()
{
  MOZ_RELEASE_ASSERT(IsStar(), "Wrong type!");
  mValue.mStar.Destroy();
  mType = eUninitialized;
}



bool
OwningStarOrStringOrSanitizerElementNamespaceSequence::TrySetToStringOrSanitizerElementNamespaceSequence(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    Sequence<OwningStringOrSanitizerElementNamespace>& memberSlot = RawSetAsStringOrSanitizerElementNamespaceSequence();
    JS::ForOfIterator iter(cx);
    if (!iter.init(value, JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      DestroyStringOrSanitizerElementNamespaceSequence();
      tryNext = true;
      return true;
    }
    Sequence<OwningStringOrSanitizerElementNamespace> &arr = memberSlot;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      OwningStringOrSanitizerElementNamespace* slotPtr = arr.AppendElement(mozilla::fallible);
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      OwningStringOrSanitizerElementNamespace& slot = *slotPtr;
      if (!slot.Init(cx, temp, "Element of sequence<(DOMString or SanitizerElementNamespace)> branch of (Star or sequence<(DOMString or SanitizerElementNamespace)>)", passedToJSImpl)) {
        return false;
      }
    }
  }
  return true;
}

bool
OwningStarOrStringOrSanitizerElementNamespaceSequence::TrySetToStringOrSanitizerElementNamespaceSequence(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return TrySetToStringOrSanitizerElementNamespaceSequence(cx, value, tryNext, passedToJSImpl);
}

Sequence<OwningStringOrSanitizerElementNamespace>&
OwningStarOrStringOrSanitizerElementNamespaceSequence::RawSetAsStringOrSanitizerElementNamespaceSequence()
{
  if (mType == eStringOrSanitizerElementNamespaceSequence) {
    return mValue.mStringOrSanitizerElementNamespaceSequence.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eStringOrSanitizerElementNamespaceSequence;
  return mValue.mStringOrSanitizerElementNamespaceSequence.SetValue();
}

Sequence<OwningStringOrSanitizerElementNamespace>&
OwningStarOrStringOrSanitizerElementNamespaceSequence::SetAsStringOrSanitizerElementNamespaceSequence()
{
  if (mType == eStringOrSanitizerElementNamespaceSequence) {
    return mValue.mStringOrSanitizerElementNamespaceSequence.Value();
  }
  Uninit();
  mType = eStringOrSanitizerElementNamespaceSequence;
  return mValue.mStringOrSanitizerElementNamespaceSequence.SetValue();
}


void
OwningStarOrStringOrSanitizerElementNamespaceSequence::DestroyStringOrSanitizerElementNamespaceSequence()
{
  MOZ_RELEASE_ASSERT(IsStringOrSanitizerElementNamespaceSequence(), "Wrong type!");
  mValue.mStringOrSanitizerElementNamespaceSequence.Destroy();
  mType = eUninitialized;
}



bool
OwningStarOrStringOrSanitizerElementNamespaceSequence::Init(BindingCallContext& cx, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  MOZ_ASSERT(mType == eUninitialized);

  bool done = false, failed = false, tryNext;
  if (value.isObject()) {
    done = (failed = !TrySetToStringOrSanitizerElementNamespaceSequence(cx, value, tryNext, passedToJSImpl)) || !tryNext;
  }
  if (!done) {
    do {
      done = (failed = !TrySetToStar(cx, value, tryNext)) || !tryNext;
      break;
    } while (false);
  }
  if (failed) {
    return false;
  }
  if (!done) {
    cx.ThrowErrorMessage<MSG_NOT_IN_UNION>(sourceDescription, "sequence<(DOMString or SanitizerElementNamespace)>");
    return false;
  }
  return true;
}

bool
OwningStarOrStringOrSanitizerElementNamespaceSequence::Init(JSContext* cx_, JS::Handle<JS::Value> value, const char* sourceDescription, bool passedToJSImpl)
{
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, value, sourceDescription, passedToJSImpl);
}

void
OwningStarOrStringOrSanitizerElementNamespaceSequence::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eStar: {
      DestroyStar();
      break;
    }
    case eStringOrSanitizerElementNamespaceSequence: {
      DestroyStringOrSanitizerElementNamespaceSequence();
      break;
    }
  }
}

bool
OwningStarOrStringOrSanitizerElementNamespaceSequence::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
    }
    case eStar: {
      if (!ToJSValue(cx, mValue.mStar.Value(), rval)) {
        return false;
      }
      return true;
    }
    case eStringOrSanitizerElementNamespaceSequence: {

      uint32_t length = mValue.mStringOrSanitizerElementNamespaceSequence.Value().Length();
      JS::Rooted<JSObject*> returnArray(cx, JS::NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            if (!mValue.mStringOrSanitizerElementNamespaceSequence.Value()[sequenceIdx0].ToJSVal(cx, returnArray, &tmp)) {
              return false;
            }
            break;
          } while (false);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      rval.setObject(*returnArray);
      return true;
    }
    default: {
      return false;
    }
  }
}

OwningStarOrStringOrSanitizerElementNamespaceSequence&
OwningStarOrStringOrSanitizerElementNamespaceSequence::operator=(OwningStarOrStringOrSanitizerElementNamespaceSequence&& aOther)
{
  this->~OwningStarOrStringOrSanitizerElementNamespaceSequence();
  new (this) OwningStarOrStringOrSanitizerElementNamespaceSequence (std::move(aOther));
  return *this;
}


OwningStarOrStringOrSanitizerElementNamespaceSequence&
OwningStarOrStringOrSanitizerElementNamespaceSequence::operator=(const OwningStarOrStringOrSanitizerElementNamespaceSequence& aOther)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eStar: {
      SetAsStar() = aOther.GetAsStar();
      break;
    }
    case eStringOrSanitizerElementNamespaceSequence: {
      SetAsStringOrSanitizerElementNamespaceSequence() = aOther.GetAsStringOrSanitizerElementNamespaceSequence();
      break;
    }
  }
  return *this;
}



SanitizerAttribute::SanitizerAttribute()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}




bool
SanitizerAttribute::InitIds(JSContext* cx, SanitizerAttributeAtoms* atomsCache)
{
  MOZ_ASSERT(reinterpret_cast<jsid*>(atomsCache)->isVoid());

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->namespace_id.init(cx, "namespace") ||
      !atomsCache->name_id.init(cx, "name") ||
      !atomsCache->elements_id.init(cx, "elements")) {
    return false;
  }
  return true;
}

bool
SanitizerAttribute::Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  SanitizerAttributeAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<SanitizerAttributeAtoms>(cx);
    if (reinterpret_cast<jsid*>(atomsCache)->isVoid() &&
        !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(val)) {
    return cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>(sourceDescription, "dictionary");
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->elements_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!mElements.Init(cx, temp.ref(), "'elements' member of SanitizerAttribute", passedToJSImpl)) {
      return false;
    }
    mIsAnyMemberPresent = true;
  } else if (cx) {
    // Don't error out if we have no cx.  In that
    // situation the caller is default-constructing us and we'll
    // just assume they know what they're doing.
    return cx.ThrowErrorMessage<MSG_MISSING_REQUIRED_DICTIONARY_MEMBER>("'elements' member of SanitizerAttribute");
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->name_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mName)) {
      return false;
    }
    mIsAnyMemberPresent = true;
  } else if (cx) {
    // Don't error out if we have no cx.  In that
    // situation the caller is default-constructing us and we'll
    // just assume they know what they're doing.
    return cx.ThrowErrorMessage<MSG_MISSING_REQUIRED_DICTIONARY_MEMBER>("'name' member of SanitizerAttribute");
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->namespace_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, mNamespace)) {
      return false;
    }
  } else {
    mNamespace.SetIsVoid(true);
  }
  mIsAnyMemberPresent = true;
  return true;
}

bool
SanitizerAttribute::Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // We don't want to use sourceDescription for our context here;
  // that's not really what it's formatted for.
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, val, sourceDescription, passedToJSImpl);
}

void
SanitizerAttribute::TraceDictionary(JSTracer* trc)
{
}

SanitizerAttribute&
SanitizerAttribute::operator=(const SanitizerAttribute& aOther)
{
  DictionaryBase::operator=(aOther);
  mElements = aOther.mElements;
  mName = aOther.mName;
  mNamespace = aOther.mNamespace;
  return *this;
}



SanitizerConfig::SanitizerConfig()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}




bool
SanitizerConfig::InitIds(JSContext* cx, SanitizerConfigAtoms* atomsCache)
{
  MOZ_ASSERT(reinterpret_cast<jsid*>(atomsCache)->isVoid());

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->dropElements_id.init(cx, "dropElements") ||
      !atomsCache->dropAttributes_id.init(cx, "dropAttributes") ||
      !atomsCache->blockElements_id.init(cx, "blockElements") ||
      !atomsCache->allowUnknownMarkup_id.init(cx, "allowUnknownMarkup") ||
      !atomsCache->allowElements_id.init(cx, "allowElements") ||
      !atomsCache->allowCustomElements_id.init(cx, "allowCustomElements") ||
      !atomsCache->allowComments_id.init(cx, "allowComments") ||
      !atomsCache->allowAttributes_id.init(cx, "allowAttributes")) {
    return false;
  }
  return true;
}

bool
SanitizerConfig::Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  SanitizerConfigAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<SanitizerConfigAtoms>(cx);
    if (reinterpret_cast<jsid*>(atomsCache)->isVoid() &&
        !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(val)) {
    return cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>(sourceDescription, "dictionary");
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->allowAttributes_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mAllowAttributes.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'allowAttributes' member of SanitizerConfig", "sequence");
        return false;
      }
      Sequence<SanitizerAttribute> &arr = (mAllowAttributes.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        SanitizerAttribute* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        SanitizerAttribute& slot = *slotPtr;
        if (!slot.Init(cx, temp, "Element of 'allowAttributes' member of SanitizerConfig", passedToJSImpl)) {
          return false;
        }
      }
    } else {
      cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'allowAttributes' member of SanitizerConfig", "sequence");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->allowComments_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mAllowComments.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), "'allowComments' member of SanitizerConfig", &(mAllowComments.Value()))) {
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->allowCustomElements_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mAllowCustomElements.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), "'allowCustomElements' member of SanitizerConfig", &(mAllowCustomElements.Value()))) {
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->allowElements_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mAllowElements.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'allowElements' member of SanitizerConfig", "sequence");
        return false;
      }
      Sequence<OwningStringOrSanitizerElementNamespace> &arr = (mAllowElements.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        OwningStringOrSanitizerElementNamespace* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        OwningStringOrSanitizerElementNamespace& slot = *slotPtr;
        if (!slot.Init(cx, temp, "Element of 'allowElements' member of SanitizerConfig", passedToJSImpl)) {
          return false;
        }
      }
    } else {
      cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'allowElements' member of SanitizerConfig", "sequence");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->allowUnknownMarkup_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mAllowUnknownMarkup.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), "'allowUnknownMarkup' member of SanitizerConfig", &(mAllowUnknownMarkup.Value()))) {
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->blockElements_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mBlockElements.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'blockElements' member of SanitizerConfig", "sequence");
        return false;
      }
      Sequence<OwningStringOrSanitizerElementNamespace> &arr = (mBlockElements.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        OwningStringOrSanitizerElementNamespace* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        OwningStringOrSanitizerElementNamespace& slot = *slotPtr;
        if (!slot.Init(cx, temp, "Element of 'blockElements' member of SanitizerConfig", passedToJSImpl)) {
          return false;
        }
      }
    } else {
      cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'blockElements' member of SanitizerConfig", "sequence");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->dropAttributes_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mDropAttributes.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'dropAttributes' member of SanitizerConfig", "sequence");
        return false;
      }
      Sequence<SanitizerAttribute> &arr = (mDropAttributes.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        SanitizerAttribute* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        SanitizerAttribute& slot = *slotPtr;
        if (!slot.Init(cx, temp, "Element of 'dropAttributes' member of SanitizerConfig", passedToJSImpl)) {
          return false;
        }
      }
    } else {
      cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'dropAttributes' member of SanitizerConfig", "sequence");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->dropElements_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mDropElements.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'dropElements' member of SanitizerConfig", "sequence");
        return false;
      }
      Sequence<OwningStringOrSanitizerElementNamespace> &arr = (mDropElements.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        OwningStringOrSanitizerElementNamespace* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        OwningStringOrSanitizerElementNamespace& slot = *slotPtr;
        if (!slot.Init(cx, temp, "Element of 'dropElements' member of SanitizerConfig", passedToJSImpl)) {
          return false;
        }
      }
    } else {
      cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>("'dropElements' member of SanitizerConfig", "sequence");
      return false;
    }
    mIsAnyMemberPresent = true;
  }
  return true;
}

bool
SanitizerConfig::Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // We don't want to use sourceDescription for our context here;
  // that's not really what it's formatted for.
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, val, sourceDescription, passedToJSImpl);
}

void
SanitizerConfig::TraceDictionary(JSTracer* trc)
{
}

SanitizerConfig&
SanitizerConfig::operator=(const SanitizerConfig& aOther)
{
  DictionaryBase::operator=(aOther);
  mAllowAttributes.Reset();
  if (aOther.mAllowAttributes.WasPassed()) {
    mAllowAttributes.Construct(aOther.mAllowAttributes.Value());
  }
  mAllowComments.Reset();
  if (aOther.mAllowComments.WasPassed()) {
    mAllowComments.Construct(aOther.mAllowComments.Value());
  }
  mAllowCustomElements.Reset();
  if (aOther.mAllowCustomElements.WasPassed()) {
    mAllowCustomElements.Construct(aOther.mAllowCustomElements.Value());
  }
  mAllowElements.Reset();
  if (aOther.mAllowElements.WasPassed()) {
    mAllowElements.Construct(aOther.mAllowElements.Value());
  }
  mAllowUnknownMarkup.Reset();
  if (aOther.mAllowUnknownMarkup.WasPassed()) {
    mAllowUnknownMarkup.Construct(aOther.mAllowUnknownMarkup.Value());
  }
  mBlockElements.Reset();
  if (aOther.mBlockElements.WasPassed()) {
    mBlockElements.Construct(aOther.mBlockElements.Value());
  }
  mDropAttributes.Reset();
  if (aOther.mDropAttributes.WasPassed()) {
    mDropAttributes.Construct(aOther.mDropAttributes.Value());
  }
  mDropElements.Reset();
  if (aOther.mDropElements.WasPassed()) {
    mDropElements.Construct(aOther.mDropElements.Value());
  }
  return *this;
}


namespace Sanitizer_Binding {

MOZ_CAN_RUN_SCRIPT static bool
sanitize(JSContext* cx_, JS::Handle<JSObject*> obj, void* void_self, const JSJitMethodCallArgs& args)
{
  BindingCallContext cx(cx_, "Sanitizer.sanitize");
  AUTO_PROFILER_LABEL_DYNAMIC_FAST(
    "Sanitizer", "sanitize", DOM, cx,
    uint32_t(js::ProfilingStackFrame::Flags::STRING_TEMPLATE_METHOD) |
    uint32_t(js::ProfilingStackFrame::Flags::RELEVANT_FOR_JS));

  auto* self = static_cast<mozilla::dom::Sanitizer*>(void_self);
  if (!args.requireAtLeast(cx, "Sanitizer.sanitize", 1)) {
    return false;
  }
  DocumentFragmentOrDocument arg0;
  if (!arg0.Init(cx, args[0], "Argument 1", false)) {
    return false;
  }
  FastErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::DocumentFragment>(MOZ_KnownLive(self)->Sanitize(Constify(arg0), rv)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx, "Sanitizer.sanitize"))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  SetUseCounter(obj, eUseCounter_Sanitizer_sanitize);
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo sanitize_methodinfo = {
  { (JSJitGetterOp)sanitize },
  { prototypes::id::Sanitizer },
  { PrototypeTraits<prototypes::id::Sanitizer>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 1, "There is no slot for us");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::Sanitizer* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::Sanitizer>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(JS::GCContext* gcx, JSObject* obj)
{
  mozilla::dom::Sanitizer* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::Sanitizer>(obj);
  if (self) {
    JS::SetReservedSlot(obj, DOM_OBJECT_SLOT, JS::UndefinedValue());
    ClearWrapper(self, self, obj);
    if (size_t mallocBytes = BindingJSObjectMallocBytes(self)) {
      JS::RemoveAssociatedMemory(obj, mallocBytes,
                                 JS::MemoryUse::DOMBinding);
    }
    AddForDeferredFinalization<mozilla::dom::Sanitizer>(self);
  }
}

static nsWrapperCache*
_getWrapperCache(JS::Handle<JSObject*> obj)
{
  mozilla::dom::Sanitizer* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::Sanitizer>(obj);
  return self;
}

static size_t
_objectMoved(JSObject* obj, JSObject* old)
{
  mozilla::dom::Sanitizer* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::Sanitizer>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }

  return 0;
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("sanitize", (GenericMethod<NormalThisPolicy, ThrowExceptions>), reinterpret_cast<const JSJitInfo*>(&sanitize_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

static const PrefableDisablers sMethods_disablers0 = {
  WebIDLPrefIndex::NoPref, 0, true, OriginTrial(0), nullptr
};

static const Prefable<const JSFunctionSpec> sMethods[] = {
  { &sMethods_disablers0, &sMethods_specs[0] },
  { nullptr, nullptr }
};

static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_PREF_INDEX,
    "We have a prefable index that is >= (1 << NUM_BITS_PROPERTY_INFO_PREF_INDEX)");
static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_SPEC_INDEX,
    "We have a spec index that is >= (1 << NUM_BITS_PROPERTY_INFO_SPEC_INDEX)");


static uint16_t sNativeProperties_sortedPropertyIndices[1];
static PropertyInfo sNativeProperties_propertyInfos[1];

static const NativePropertiesN<1> sNativeProperties = {
  false, 0,
  false, 0,
  true,  0 /* sMethods */,
  false, 0,
  false, 0,
  false, 0,
  false, 0,
  -1,
  1,
  sNativeProperties_sortedPropertyIndices,
  {
    { sMethods, &sNativeProperties_propertyInfos[0] }
  }
};
static_assert(1 < 1ull << (CHAR_BIT * sizeof(sNativeProperties.propertyInfoCount)),
    "We have a property info count that is oversized");

bool sNativePropertiesInited = false;
const NativePropertyHooks sNativePropertyHooks = {
  nullptr,
  nullptr,
  nullptr,
  { sNativeProperties.Upcast(), nullptr, &sNativePropertiesInited },
  prototypes::id::Sanitizer,
  constructors::id::Sanitizer,
  &DefaultXrayExpandoObjectClass
};

static bool
_constructor(JSContext* cx_, unsigned argc, JS::Value* vp)
{
  BindingCallContext cx(cx_, "Sanitizer constructor");
  AUTO_PROFILER_LABEL_DYNAMIC_FAST(
    "Sanitizer", "constructor", DOM, cx,
    uint32_t(js::ProfilingStackFrame::Flags::RELEVANT_FOR_JS));

  JS::CallArgs args = JS::CallArgsFromVp(argc, vp);
  JS::Rooted<JSObject*> obj(cx, &args.callee());
  if (!args.isConstructing()) {
    return ThrowConstructorWithoutNew(cx, "Sanitizer");
  }

  JS::Rooted<JSObject*> desiredProto(cx);
  if (!GetDesiredProto(cx, args,
                       prototypes::id::Sanitizer,
                       CreateInterfaceObjects,
                       &desiredProto)) {
    return false;
  }

  GlobalObject global(cx, obj);
  if (global.Failed()) {
    return false;
  }

  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  binding_detail::FastSanitizerConfig arg0;
  if (!arg0.Init(cx, (args.hasDefined(0)) ? args[0] : JS::NullHandleValue, "Argument 1", false)) {
    return false;
  }
  Maybe<JSAutoRealm> ar;
  if (objIsXray) {
    // Since our object is an Xray, we can just CheckedUnwrapStatic:
    // we know Xrays have no dynamic unwrap behavior.
    obj = js::CheckedUnwrapStatic(obj);
    if (!obj) {
      return false;
    }
    ar.emplace(cx, obj);
    if (!JS_WrapObject(cx, &desiredProto)) {
      return false;
    }
  }
  FastErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Sanitizer>(mozilla::dom::Sanitizer::Constructor(global, Constify(arg0), rv)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx, "Sanitizer constructor"))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  SetUseCounter(obj, eUseCounter_Sanitizer_constructor);
  static_assert(!std::is_pointer_v<decltype(result)>,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval(), desiredProto)) {
    MOZ_ASSERT(JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSClassOps sInterfaceObjectClassOps = {
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* enumerate */
    nullptr,               /* newEnumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* finalize */
    _constructor, /* call */
    _constructor, /* construct */
    nullptr,               /* trace */
};

static const DOMIfaceAndProtoJSClass sInterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    &sInterfaceObjectClassOps,
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    &sInterfaceObjectClassObjectOps
  },
  eInterface,
  true,
  prototypes::id::Sanitizer,
  PrototypeTraits<prototypes::id::Sanitizer>::Depth,
  &sNativePropertyHooks,
  "function Sanitizer() {\n    [native code]\n}",
  JS::GetRealmFunctionPrototype
};

static const DOMIfaceAndProtoJSClass sPrototypeClass = {
  {
    "SanitizerPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    JS_NULL_CLASS_OPS,
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  false,
  prototypes::id::Sanitizer,
  PrototypeTraits<prototypes::id::Sanitizer>::Depth,
  &sNativePropertyHooks,
  nullptr,
  JS::GetRealmObjectPrototype
};

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return StaticPrefs::dom_security_sanitizer_enabled() &&
         mozilla::dom::IsSecureContextOrObjectIsFromSecureContext(aCx, aObj);
}

static const JSClassOps sClassOps = {
  _addProperty, /* addProperty */
  nullptr,               /* delProperty */
  nullptr,               /* enumerate */
  nullptr, /* newEnumerate */
  nullptr, /* resolve */
  nullptr, /* mayResolve */
  _finalize, /* finalize */
  nullptr, /* call */
  nullptr,               /* construct */
  nullptr, /* trace */
};

static const js::ClassExtension sClassExtension = {
  _objectMoved /* objectMovedOp */
};

static const DOMJSClass sClass = {
  { "Sanitizer",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_FOREGROUND_FINALIZE | JSCLASS_HAS_RESERVED_SLOTS(1),
    &sClassOps,
    JS_NULL_CLASS_SPEC,
    &sClassExtension,
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::Sanitizer, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  std::is_base_of_v<nsISupports, mozilla::dom::Sanitizer>,
  &sNativePropertyHooks,
  FindAssociatedGlobalForNative<mozilla::dom::Sanitizer>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::Sanitizer>::Get(),
  nullptr,
  _getWrapperCache
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

bool
Wrap(JSContext* aCx, mozilla::dom::Sanitizer* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  static_assert(!std::is_base_of_v<NonRefcountedDOMObject, mozilla::dom::Sanitizer>,
                "Shouldn't have wrappercached things that are not refcounted.");
  static_assert(std::is_same_v<decltype(aObject), mozilla::dom::Sanitizer*>);
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT_IF(aGivenProto, js::IsObjectInContextCompartment(aGivenProto, aCx));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  // If the wrapper cache contains a dead reflector then finalize that
  // now, ensuring that the finalizer for the old reflector always
  // runs before the new reflector is created and attached. This
  // avoids the awkward situation where there are multiple reflector
  // objects that contain pointers to the same native.

  if (JSObject* oldReflector = aCache->GetWrapperMaybeDead()) {
    _finalize(nullptr /* unused */, oldReflector);
    MOZ_ASSERT(!aCache->GetWrapperMaybeDead());
  }

  JS::Rooted<JSObject*> global(aCx, FindAssociatedGlobal(aCx, aObject->GetParentObject()));
  if (!global) {
    return false;
  }
  MOZ_ASSERT(JS_IsGlobalObject(global));
  JS::AssertObjectIsNotGray(global);

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoRealm ar(aCx, global);
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != JS::GetCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::Sanitizer> creator(aCx);
  creator.CreateObject(aCx, sClass.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Rooted<JSObject*> parentProto(aCx, JS::GetRealmObjectPrototype(aCx));
  if (!parentProto) {
    return;
  }

  JS::Rooted<JSObject*> constructorProto(aCx, JS::GetRealmFunctionPrototype(aCx));
  if (!constructorProto) {
    return;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::Sanitizer);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::Sanitizer);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &sPrototypeClass.mBase, protoCache,
                              constructorProto, &sInterfaceObjectClass.mBase, 0, false, nullptr,
                              interfaceCache,
                              sNativeProperties.Upcast(),
                              nullptr,
                              "Sanitizer", aDefineOnGlobal,
                              nullptr,
                              false,
                              nullptr,
                              false);
}

JSObject*
GetConstructorObject(JSContext* aCx)
{
  return GetConstructorObjectHandle(aCx);
}

} // namespace Sanitizer_Binding



} // namespace mozilla::dom
